<HTML>
<HEAD>
<TITLE>Scaler Record and related software</TITLE>
</HEAD>
<BODY>
<H1>Scaler Record and related software</H1>

<ADDRESS>Tim Mooney</ADDRESS>

<HR>
<H2>Contents</H2>
<UL>
<LI><A HREF="#Overview">Overview</A>
<LI><A HREF="#Fields">Field Descriptions</A>
<LI><A HREF="#Files">Files, device-support</A>
<LI><A HREF="#Restrictions">Restrictions</A>
</UL>

<A NAME="Overview">
<H2>Overview</H2></A>

<P>The scaler record provides support for a bank of up to 64 32-bit counters
(scaler channels) controlled by a common start/stop mechanism.  If the
hardware is capable of preset-counter operation, the record divides scaler
channels into two groups according to the values of each channel's
gate-control field (Gn): simple counters [Gn = "N" (0)], and preset counters
[Gn = "Y" (1)].  Simple counters are zeroed immediately before counting
begins, and count upwards.  Preset counters are simple counters that will not
count higher than a preset value.  The first preset counter to reach its
preset value stop all counters.  (The hardware may actually implement a
preset counter by loading in the preset value, and counting down to zero.  If
so, device support is expected to maintain the fiction that all counters
count up from zero.)  Currently device support exists for the Joerger VSC
8 and 16 channel VME scalers; Joerger VS64 fly-counting scalers; the
SIS3801 multichannel scaler, emulating a single scaler bank, and the SIS3820.
Joerger VS scalers do not support preset counting, so the software sets the Gn fields
to 0 and keeps them there.

<P>Scaler channel 1 receives special treatment: it is presumed to count a
reference-frequency clock signal and its value indicates the time interval
during which counting was enabled.  The fields

<UL>
<LI>T (time)
<LI>TP (time preset)
<LI>S1 (scaler channel 1 value)
<LI>PR1 (scaler channel 1 preset value), and
<LI>FREQ (clock frequency)
</UL> satisfy the following equations:
<PRE>
	T = S1 / FREQ
	TP = PR1 / FREQ
</PRE>

The manner in which the time base is managed is different for different
kinds of scaler hardware.

<DL>

<DT>Joerger VSC scalers <DD>It is the user's job to make sure that a
clock signal is presented to the channel-1 input, and that FREQ actually
contains the frequency of the clock signal.  The 10 MHz signal available on
the front panel normally is used for this purpose.

<DT>SIS3801 scalers <DD>Normally, the hardware is set up to connect an
internally generated 25-MHz clock to channel 1, via a software switch.
(Thus, any external signal connected to SIS3801 channel 1 will be ignored.)
It is possible to use an externally generated clock, and in any case it is
still the user's responsibility to ensure that FREQ contains the correct
value.  The SIS3801 does not support hardware presets.  However, presets are emulated as follows. 
The scaler is uses a FIFO to buffer the counts in each dwell period.  For the scaler
record mode (as opposed to the MCS mode used with the MCA record) the dwell time is
set to 0.01 seconds.  Thus, every 0.01 seconds the counts for each channel are pushed into
the FIFO stack.  When the driver reads the FIFO at the scaler polling rate (.RATE) it compares 
the total counts for each channel with the preset counts.  If any preset is reached then it
signals that counting is complete.  Thus, the counting could have extended for up to 0.01 second
longer than requested, but each channel will have counted for exactly the same period of time,
so the counts per second will be accurate.

<DT>SIS3820 scalers <DD> Normally the hardware is set up to connect an
internally generated 50-MHz clock to channel 1, via a software switch. 
The SIS3820 supports hardware presets.  
However, there is only a single preset for channels 1-16,
and a second preset for channels 17-32.  This means that only one channel from 1-16 and one channel
from 17-32 can be used as a preset at the same time. The driver handles this limitation by using the
highest numbered channel in each group that has a non-zero preset (PRn) and active gate (Gn=Y).
For example, if PR1, PR3, PR18 and PR22 are all non-zero and G1,G3,G18 and G22 are "Y", 
then the scaler will stop counting when S3=PR3 or S22=PR22, whichever comes first.

<DT>Joerger VS scalers <DD>This hardware does not implement preset
counters; an internal 16-bit gate-time counter is used to set the counting
time.  The device-support software will choose a reference frequency for this
counter, and cause the hardware to generate and use it.  Also, device-support
will set and post the FREQ field according to the reference frequency it has
chosen.  But the reference signal still must be connected by the user to the
channel-1 input, so that the record and any clients can treat channel 1 as
the time base.

</DL>

<P>This is how the scaler record is intended to be used:
<OL>
<LI>The user sets FREQ to the frequency of the clock signal input to
    scaler channel 1. (Joerger VSC, SIS3801, and SIS3820 only)
<LI>The user sets TP (time preset) and/or PRn (preset value for scaler
    channel n).  (For Joerger VS scalers, only TP or PR1 may be set.)
<LI>The user sets CNT to "Count" (1), initiating counting.
<LI>For Joerger VSC, SIS3801 and SIS3820 scalers, the counters count until any
    preset counter reaches its preset value, whereupon the record resets
    CNT to "Done" (0), or the user manually resets CNT to "Done" (0),
    causing counting to stop.  For Joerger VS scalers, counters count
    until the internal gate-time counter reaches its preset, or the user
    manually resets CNT to "Done" (0).
</OL>

<P>This version of the scaler record maintains two counting modes: normal and
background (also called AutoCount).  Normal counting is controlled by the CNT
("Count/Done") field, the time preset, and possibly other presets, as
described above.  Background counting is controlled by the CONT
("OneShot/AutoCount") field, normally ignores user preset values, and is
intended to give the user continuous updates whenever the scaler would
otherwise be idle.

<P>When CONT = "AutoCount" (1), and no normal counting operation is
already in progress, the scaler waits for the AutoCount delay (DLY1);
counts for the AutoCount period (TP1); and displays the result.  If the
AutoCount period (TP1) is less than .001 s, we default to the normal
criteria for determining the count period.  If the AutoCount Display
Rate (RAT1) is greater than zero (Hz), then the scaler values are
displayed at that rate while background counting is in progress.

<P>Background counting is interrupted immediately whenever a normal
counting operation is started with the CNT field, and the results of a
normal counting operation are held for ten seconds after the scaler
finishes normal counting, before background counting begins again.
The ten-second data-hold period can be changed by setting the integer
variable 'scaler_wait_time' to the desired hold time in seconds, either
at the ioc console, or in the ioc-startup file, st.cmd.

<P>Background counting never affects the state of the CNT field, so this
field can always be used to determine when a normal counting operation
has begun and finished.

<P>The scaler record is unlike most other EPICS records in that its
processing is neither "synchronous" nor "asynchronous", as these terms
are used in the EPICS Application Developer' Guide.  Currently, the PACT
field is always FALSE after record processing has completed, even
though the scaler may be counting.  This means the record always
responds to channel-access puts, and that counting can be stopped at
any time.  The record's forward link is not executed until the scaler
has stopped counting.


<A NAME="Fields">
<H2>Field Descriptions</H2></A>
<P>In addition to fields common to all record types (see the EPICS
Record Reference Manual for these) the scaler record has the fields
described below.
<UL>
<LI><A HREF="#Fields_alphabetical">Alphabetical listing of all fields</A>
<LI><A HREF="#Fields_control">Control/status fields:</A>
<LI><A HREF="#Fields_data">Data fields</A>
<LI><A HREF="#Fields_link">Link fields</A>
<LI><A HREF="#Fields_misc">Miscellaneous fields</A>
<LI><A HREF="#Fields_private">Private fields</A>
</UL>

<HR>
<TABLE BORDER CELLPADDING=1>
<A NAME="Fields_alphabetical">
<CAPTION><H2>Alphabetical list of record-specific fields</H2>
NOTE: Hot links in this table take you only to the <EM>section</EM> in which
the linked item is described in detail.  You'll probably have to scroll down to
find the actual item.</CAPTION></A>

<TR>								<TH>Name		<TH>Access	<TH>Prompt				<TH>Data type	<TH>Comment

<TR><TD><A HREF="#Fields_control">	CNT		</A>	<TD>R/W*	<TD>Count				<TD>RECCHOICE	<TD>(0:"Done", 1:"Count")
<TR><TD><A HREF="#Fields_control">	CONT	</A>	<TD>R/W*	<TD>OneShot/AutoCount	<TD>RECCHOICE	<TD>(0:"OneShot", 1:"AutoCount")
<TR><TD><A HREF="#Fields_link">		COUT	</A>	<TD>R/W		<TD>CNT Output			<TD>OUTLINK		<TD>Link to PV
<TR><TD><A HREF="#Fields_link">		COUTP	</A>	<TD>R/W		<TD>Prompt COUT			<TD>OUTLINK		<TD>Link to PV
<TR><TD><A HREF="#Fields_private">	D1...D64</A>	<TD>R/W		<TD>Count Direction n	<TD>RECCHOICE	<TD>(0:"Up", 1:"Dn")
<TR><TD><A HREF="#Fields_control">	DLY		</A>	<TD>R/W		<TD>Delay				<TD>FLOAT		<TD>before counting
<TR><TD><A HREF="#Fields_control">	DLY1	</A>	<TD>R/W		<TD>Auto-mode Delay		<TD>FLOAT		<TD>before counting
<TR><TD><A HREF="#Fields_misc">		EGU		</A>	<TD>R/W		<TD>Units Name			<TD>STRING		<TD>8 characters
<TR><TD><A HREF="#Fields_data">		FREQ	</A>	<TD>R/W		<TD>Time base freq		<TD>DOUBLE		<TD>e.g., 1e7
<TR><TD><A HREF="#Fields_control">	G1...G64</A>	<TD>R/W		<TD>Gate Control n		<TD>RECCHOICE	<TD>preset? (0:"N", 1:"Y")
<TR><TD><A HREF="#Fields_misc">		NCH		</A>	<TD>R		<TD>Number of Channels	<TD>SHORT		<TD>from device
<TR><TD><A HREF="#Fields_misc">		NM1...NM64</A>	<TD>R/W		<TD>Scaler n name		<TD>STRING		<TD>user's field
<TR><TD><A HREF="#Fields_link">		OUT		</A>	<TD>R		<TD>Output Specification<TD>OUTLINK		<TD>link to hardware
<TR><TD><A HREF="#Fields_private">	PCNT	</A>	<TD>R		<TD>Prev Count			<TD>RECCHOICE	<TD>private
<TR><TD><A HREF="#Fields_misc">		PREC	</A>	<TD>R/W		<TD>Display Precision	<TD>SHORT		<TD>num decimal places
<TR><TD><A HREF="#Fields_control">	PR1...PR64</A>	<TD>R/W		<TD>Preset n			<TD>ULONG		<TD>preset values
<TR><TD><A HREF="#Fields_control">	RATE	</A>	<TD>R/W		<TD>Display Rate (Hz)	<TD>FLOAT		<TD>in [0..60] Hz
<TR><TD><A HREF="#Fields_control">	RAT1	</A>	<TD>R/W		<TD>Auto Display Rate	<TD>FLOAT		<TD>in [0..60] Hz
<TR><TD><A HREF="#Fields_private">	RPVT	</A>	<TD>r		<TD>private				<TD>void *		<TD>private
<TR><TD><A HREF="#Fields_data">		S1...S64</A>	<TD>R		<TD>Scaler n			<TD>ULONG		<TD>results
<TR><TD><A HREF="#Fields_private">	SS</A>			<TD>r		<TD>Scaler state		<TD>SHORT		<TD>state of hardware
<TR><TD><A HREF="#Fields_data">		T		</A>	<TD>R		<TD>Timer				<TD>DOUBLE		<TD>elapsed time
<TR><TD><A HREF="#Fields_control">	TP		</A>	<TD>R/W		<TD>Time Preset			<TD>DOUBLE		<TD>preset time
<TR><TD><A HREF="#Fields_control">	TP1		</A>	<TD>R/W		<TD>Time Preset			<TD>DOUBLE		<TD>preset time (auto mode)
<TR><TD><A HREF="#Fields_private">	US</A>			<TD>r		<TD>User state			<TD>SHORT		<TD>state of user request
<TR><TD><A HREF="#Fields_private">	VAL		</A>	<TD>R/W		<TD>Result				<TD>DOUBLE		<TD>posted when counting is done
<TR><TD><A HREF="#Fields_misc">		VERS	</A>	<TD>R		<TD>Code Version		<TD>FLOAT		<TD>code version

<TR VALIGN=TOP>
<TD COLSPAN=5, ALIGN=LEFT>
<TABLE>
<TD COLSPAN=3> Note: In the <B>Access</B> column above: </TD>
<TR VALIGN=TOP>
<TD>R</TD>    <TD>Read only<TD>
</TR>
<TR VALIGN=TOP>
<TD>r</TD>    <TD>Read only, not posted<TD>
</TR>
<TR VALIGN=TOP>
<TD>R/W</TD>  <TD>Read and write are allowed</TD>
</TR>
<TR VALIGN=TOP>
<TD>R/W*</TD> <TD>Read and write are allowed; write triggers record 
processing if the record's SCAN field is set to "Passive."</TD>
</TR>
<TR VALIGN=TOP>
<TD>N</TD>    <TD>No access allowed</TD>
</TR>
</TABLE>

</TABLE>
</HR>


<HR>
<TABLE BORDER CELLPADDING=5>
<A NAME="Fields_control">
<CAPTION><H2>Control/status fields</H2></CAPTION></A>
<TR VALIGN=TOP><TH>Name	<TH>Access	<TH>Prompt				<TH>Data type		<TH>Comments

<TR VALIGN=TOP><TD>CNT	<TD>R/W*	<TD>Count	<TD>RECCHOICE <TD>(0:"Done", 1:"Count")
	<TR><TD COLSPAN=5>
User sets this field to "Count" (1) to start counting.  When a preset is reached,
counting will stop, this field will be reset to "Done" (0), and the forward
link will be fired.  If this field is set to "Done" (0) while counting is in
progress, counting will be stopped, the accumulated counts will be reported,
and the forward link will be fired.

<TR VALIGN=TOP><TD>CONT	<TD>R/W*	<TD>OneShot/AutoCount	<TD>RECCHOICE <TD>(0:"OneShot", 1:"AutoCount")
	<TR><TD COLSPAN=5>
User sets this field to "AutoCount" (1) to enable background counting.
(See also autocount delay (DLY1), autocount display rate (RAT1), and autocount time presetTP1.)

<TR VALIGN=TOP><TD>G1...G64	<TD>R/W	<TD>Gate control	<TD>RECCHOICE <TD>(0:"N", 1:"Y")

	<TR><TD COLSPAN=5>
There are 64 of these fields, one per channel.  These fields determine
whether the associated scalers are to be used as simple scalers (Gn=0)
or preset scalers (Gn=1), assuming the hardware is capable.  When Gn is
set to 1, the record will ensure than PRn is nonzero (will set it to 1000,
if it was zero).  When PRn is set to any positive value, the record will
set Gn to 1.  If the hardware does not implement preset scalers, device
support will set these fields to 0 whenever it notices that they have been
set to 1.

<TR VALIGN=TOP><TD>PR1...PR64	<TD>R/W	<TD>Preset n	<TD>ULONG

	<TR><TD COLSPAN=5>
Preset values for the associated scalers.  If scaler n has been
designated as a preset scaler (i.e., if Gn=1), then when the scaler
reaches the count PRn, all scalers will be disabled, and the record
will report counting has completed by setting CNT=0.  If scaler n has
not been designated as a preset scaler, the PRn is ignored.  When PRn
changes to any positive value, the record will set Gn to 1.

<TR VALIGN=TOP><TD>TP	<TD>R/W	<TD>Time preset	<TD>DOUBLE

	<TR><TD COLSPAN=5>
This field specifies for how long, in seconds, the scaler is to count
if no other preset stops it.  TP is effectively a proxy for the preset
field, PR1, associated with scaler 1.  Whenever TP changes, the record
will set PR1 = TP*FREQ, and otherwise behave as though the user had
changed PR1.

<TR VALIGN=TOP><TD>TP1	<TD>R/W	<TD>AutoCount Time preset	<TD>DOUBLE

	<TR><TD COLSPAN=5>
This field specifies the background-counting period in seconds.

<TR VALIGN=TOP><TD>DLY	<TD>R/W	<TD>Delay (sec)		<TD>FLOAT

	<TR><TD COLSPAN=5>
The delay, in seconds, that the record is to wait after
CNT goes to 1 before actually causing counting to begin.

<TR VALIGN=TOP><TD>DLY1	<TD>R/W	<TD>AutoCount Delay (sec)		<TD>FLOAT

	<TR><TD COLSPAN=5>
The delay, in seconds, between successive background-counting periods.

<TR VALIGN=TOP><TD>RATE	<TD>R/W	<TD>Display rate (Hz)		<TD>FLOAT

	<TR><TD COLSPAN=5>
This field specifies the rate in Hz at which the scaler record posts
scaler information while counting is in progress.  If this field is
zero, counts are displayed only after counting has stopped.  Max.
rate:  60 Hz

<TR VALIGN=TOP><TD>RAT1	<TD>R/W	<TD>AutoCount Display rate (Hz)		<TD>FLOAT

	<TR><TD COLSPAN=5>
This field specifies the rate in Hz at which the scaler record posts
scaler information while background counting is in progress.  If this field is
zero, counts are displayed only after background counting has stopped.  Max.
rate:  60 Hz

<TR VALIGN=TOP><TD><TD><TD><TD><TD>
</TABLE>


<HR>
<TABLE BORDER CELLPADDING=5>
<A NAME="Fields_data">
<CAPTION><H2>Data fields</H2></CAPTION></A>
<TR VALIGN=TOP><TH>Name	<TH>Access	<TH>Prompt				<TH>Data type		<TH>Comments

<TR VALIGN=TOP><TD>FREQ	<TD>R/W	<TD>Time base freq. (EGU)		<TD>DOUBLE

	<TR><TD COLSPAN=5>
The frequency (in Hz) of the clock signal counted by scaler 1.  The
record uses this field to convert between time values (T and TP, in
seconds) and values associated with scaler 1 (S1 and PR1).  It is
the user's responsibility to ensure that this field has the correct
value.

<TR VALIGN=TOP><TD>S1...S64	<TD>R	<TD>Scaler n value (EGU)		<TD>ULONG

	<TR><TD COLSPAN=5>
The counts accumulated by the scalers.  These are posted periodically (at RATE Hz)
while counting is in progress, and once after counting stops.

<TR VALIGN=TOP><TD>T	<TD>R	<TD>Timer (EGU)		<TD>DOUBLE

	<TR><TD COLSPAN=5>
This field is a proxy for the value field, S1, associated with scaler
1.  Whenever S1 changes, the record will set T = S1/FREQ.


</TABLE>
</HR>

<HR>
<TABLE BORDER CELLPADDING=5>
<A NAME="Fields_link">
<CAPTION><H2>Link fields</H2></CAPTION></A>
<TR VALIGN=TOP><TH>Name	<TH>Access	<TH>Prompt				<TH>Data type		<TH>Comments
<TR VALIGN=TOP><TD>COUT	<TD>R/W		<TD>CNT Output			<TD>OUTLINK			<TD>link to EPICS PV to which CNT field's value is written when a user count
sequence has just started, or has just finished.
<TR VALIGN=TOP><TD>COUTP<TD>R/W		<TD>Prompt CNT Output	<TD>OUTLINK			<TD>link to EPICS PV to which CNT field's value is written when a user count
sequence has just been commanded, or has just finished.  This outlink is not delayed, as is COUT, by the DLY field.

<TR VALIGN=TOP><TD>OUT	<TD>R	<TD>Output Specification	<TD>OUTLINK

	<TD>This field specifies the hardware to be controlled.

</TABLE>
</HR>


<HR>
<TABLE BORDER CELLPADDING=5>
<A NAME="Fields_misc">
<CAPTION><H2>Miscellaneous fields</H2></CAPTION></A>
<TR VALIGN=TOP><TH>Name	<TH>Access	<TH>Prompt				<TH>Data type		<TH>Comments

<TR VALIGN=TOP><TD>NM1...NM64	<TD>R/W		<TD>Scaler n name		<TD>STRING

	<TD>Names the user has given to individual scaler channels.

<TR VALIGN=TOP><TD>PREC	<TD>R/W		<TD>Display Precision		<TD>SHORT

	<TD>The number of digits to the right of the decimal that are to be
	displayed by MEDM and other channel-access clients.

<TR VALIGN=TOP><TD>EGU	<TD>R/W		<TD>Engineering Units		<TD>STRING

	<TD>String sent to channel-access clients who ask for engineering units.

<TR VALIGN=TOP><TD>VERS	<TD>R		<TD>Code Version			<TD>FLOAT

	<TD>Version number of the recScaler.c code.


<TR VALIGN=TOP><TD>NCH	<TD>R		<TD>Number of channels				<TD>SHORT

	<TD>
The number of channels actually supported by the underlying hardware,
as reported by device support.

</TABLE>
</HR>
<HR>

<TABLE BORDER CELLPADDING=5>
<A NAME="Fields_private">
<CAPTION><H2>Private fields</H2></CAPTION></A>
<TR VALIGN=TOP><TH>Name	<TH>Access	<TH>Prompt				<TH>Data type		<TH>Comments

<TR VALIGN=TOP><TD>D1...D64 	<TD>R/W	<TD>Count direction	<TD>RECCHOICE 		<TD>(0:"Up", 1:"Dn")

	<TR><TD COLSPAN=5>
These fields are intended for the private use of the record, and may
disappear or become read-only in the future.  For scaler n, Dn is
direction in which the hardware actually counts.

<TR VALIGN=TOP><TD>PCNT 		<TD>R/W	<TD>Previous count	<TD>RECCHOICE 		<TD>(0:"Done", 1:"Count")

	<TR><TD COLSPAN=5>
Previous value of CNT.

<TR VALIGN=TOP><TD>SS 		<TD>r	<TD>Scaler state	<TD>SHORT		<TD>state of hardware

	<TR><TD COLSPAN=5>

<TR VALIGN=TOP><TD>US 		<TD>r	<TD>User state	<TD>SHORT		<TD>state of user's request

	<TR><TD COLSPAN=5>

<TR VALIGN=TOP><TD>VAL 			<TD>R/W	<TD>Result			<TD>DOUBLE 			<TD>Set to value of the T
field, and posted when counting is done, after all other fields have been posted.

</TABLE>
</HR>






<HR>
<P>
<A NAME="Files"><H2>Files, device support</H2></A> The following table
briefly describes the files required to implement and use the
scaler record.
<P>
<TABLE BORDER CELLPADDING=5>
<TR><TH COLSPAN=2>SOURCE CODE<BR></TH></TR>
<TR VALIGN=TOP><TD>scalerRecord.c		<TD>Record support for the scaler record</TR>
<TR VALIGN=TOP><TD>devScalerAsyn.c		<TD>Device support for asyn scaler drivers</TR>
<TR VALIGN=TOP><TD>devScaler.h			<TD>Header included by record and device support</TR>
<TR VALIGN=TOP><TD>devScaler.c			<TD>Device support for Joerger VSC scalers</TR>
<TR VALIGN=TOP><TD>devScaler_VS.c		<TD>Device support for Joerger VS scalers</TR>
<TR VALIGN=TOP><TD>devScalerSTR7201.c	<TD>Device support for Struck 7201 and SIS3801</TR>
<TR VALIGN=TOP><TD>drvMcaSIS3820Asyn.c	<TD>Device support for Struck 7201 and SIS3801</TR>

<TR VALIGN=TOP>
<TD>scalerRecord.dbd</TD>
<TD>This file defines all of the fields menus, etc. for the scaler record.</TD>
</TR>

<TR VALIGN=TOP>
<TD>*Include.dbd</TD>

<TD>This file is loaded at ioc-boot time, and by database-configuration tools, and --
for purposes here -- describes the scaler-record fields, and the kinds of devices that
may be associated with the scaler record.  Normally the file contains the following
scaler-related information:

<PRE>
# Database definition for scaler record
include "scalerRecord.dbd"
# Device support for scaler record
device(scaler,INST_IO,devScalerAsyn,"Asyn Scaler")
device(scaler,VME_IO,devScaler,"Joerger VSC8/16")
device(scaler,VME_IO,devScaler_VS,"Joerger VS")
device(scaler,VME_IO,devScalerSTR7201,"Struck STR7201 Scaler")
device(scaler,VME_IO,devScalerCamac,"CAMAC scaler")
</PRE></TD>
</TR>
</TABLE>

<P><TABLE BORDER CELLPADDING=5>
<TR><TH COLSPAN=2>DATABASE and AUTOSAVE-REQUEST FILES<BR></TH></TR>
<TR><TD>scaler.db<TD>database used for all device types.</TR>
<TR><TD>scaler_settings.req<TD>copy of scaler_64ch_settings.req</TR>
<TR><TD>scaler_8ch_settings.req<TD>settings for 8-channel scaler</TR>
<TR><TD>scaler_16ch_settings.req<TD>settings for 16-channel scaler</TR>
<TR><TD>scaler_32ch_settings.req<TD>settings for 32-channel scaler</TR>
<TR><TD>scaler_64ch_settings.req<TD>settings for 64-channel scaler</TR>
<TR><TD>scaler_channelN_settings.req<TD>included by other .req files</TR>
</TABLE>

<P><TABLE BORDER CELLPADDING=5>
<TR><TH COLSPAN=2>MEDM DISPLAY FILES<BR></TH></TR>
<TR VALIGN=TOP><TD>scaler.adl		<TD>tiny operator screen for 8-channel scaler
<TR VALIGN=TOP><TD>scaler16.adl		<TD>same, but for 16-channel scaler
<TR VALIGN=TOP><TD>scaler32.adl		<TD>same, but for 32-channel scaler
<TR VALIGN=TOP><TD>scaler_more.adl		<TD>medium operator screen
<TR VALIGN=TOP><TD>scaler16_more.adl	<TD>same, but for 16-channel scaler
<TR VALIGN=TOP><TD>scaler32_more.adl	<TD>same, but for 32-channel scaler
<TR VALIGN=TOP><TD>scaler_full.adl		<TD>big operator screen
<TR VALIGN=TOP><TD>scaler16_full.adl	<TD>same, but for 16-channel scaler
<TR VALIGN=TOP><TD>scaler32_full.adl	<TD>same, but for 32-channel scaler
<TR VALIGN=TOP><TD>scaler_full_calc.adl	<TD>big operator screen with user calculations
<TR VALIGN=TOP><TD>scaler16_full_calc.adl	<TD>same, but for 16-channel scaler
<TR VALIGN=TOP><TD>scaler32_full_calc.adl	<TD>same, but for 32-channel scaler

<TR><TD COLSPAN=2>These files build <CODE>medm</CODE> screens to access the scaler
record and related process variables.
To use one of them from the command line, type, for example
<PRE>
medm -x -macro "P=XXX:,S=scaler1" scaler.adl
</PRE>
<P>
where <CODE>XXX:scaler1</CODE> is the name of a scaler record in an IOC.
<P>
These files can also be used as related displays from other <CODE>medm</CODE>
screens by passing the argument <CODE>"P=XXX:,S=scaler1"</CODE>.
</TD>
</TR>
</TABLE>


<P><TABLE BORDER CELLPADDING=5>
<TR><TH COLSPAN=2>EPICS STARTUP FILE<BR></TH> </TR>

<TR VALIGN=TOP><TD>st.cmd		<TD>Startup script
<TR><TD COLSPAN=2>
This file is not included in the distribution.  Here are annotated excerpts
from a startup file that supports scalers: 
<PRE>
#######################################################################
# vxWorks startup script to load and execute system (iocCore) software.
</PRE>

<B><FONT COLOR=#FFFFFF> Scaler-related databases </FONT></B>
<PRE>
# Tell EPICS all about the record types, device-support modules, drivers,
# etc. in the software we just loaded (xxxApp)
dbLoadDatabase("dbd/xxxApp.dbd")

# scalers
dbLoadRecords("$(STD)/stdApp/Db/scaler16m.db","P=xxx:,S=scaler1,OUT=#C0 S0 @,DTYP=Joerger VSC8/16,FREQ=10000000")
dbLoadRecords("$(STD)/stdApp/Db/scaler16m.db","P=xxx:,S=scaler2,OUT=#C0 S0 @,DTYP=Joerger VS,FREQ=10000000")
dbLoadRecords("$(STD)/stdApp/Db/scaler16m.db","P=xxx:,S=scaler3,OUT=#C0 S0 @,DTYP=Struck STR7201 Scaler,FREQ=25000000")
dbLoadRecords("$(STD)/stdApp/Db/scaler16m.db","P=xxx:,S=scaler4,OUT=#C0 S0 @,DTYP=CAMAC scaler,FREQ=10000000")
dbLoadRecords("$(STD)/stdApp/Db/scaler32.db", "P=xxx:,S=scaler5,OUT=@asyn($(PORT)),DTYP=Asyn Scaler,FREQ=50000000")
</PRE>

<blockquote>
<P><TABLE BORDER CELLPADDING=5>
<TR><TH COLSPAN=2><PRE>
VSCSetup(int nCards, char *baseAddress, unisgned intVectBase)
</PRE>
</TH>
<TR VALIGN=TOP><TD>nCards</TD>
<TD>the actual number of cards may be less than, but not greater than this
</TR>
<TR VALIGN=TOP><TD>baseAddress</TD>
<TD>the base address of the first card of a series.  This must agree
with address jumpers on the actual card(s).
<P>Joerger VSC8 and VSC16 have base addresses in the A32 address space,
on a 256-byte (0x100) boundary.  (I.e., these cards require 256 bytes
each, and must all be addressed contiguously as, e.g., 0xB0000000,
0xB0000100,...).
</TD></TR>
<TR VALIGN=TOP><TD>intVectBase</TD>
<TD>the interrupt vector that will be loaded into the first card of a
series.  Succeeding cards will be loaded with intVectBase+1,
intVectBase+2, etc.  Stay in the range [64..255].  (The interrupt <EM>level</EM>
is read from the hardware.)</TD>
</TR>
</TABLE>
</FONT>
</blockquote>

<PRE>VSCSetup(2, 0xB0000000, 200)</PRE>

<blockquote>
<P><TABLE BORDER CELLPADDING=5>
<TR><TH COLSPAN=2><PRE>
scalerVS_Setup(int nCards, char *baseAddress, unsigned intVectBase, int intLevel)
</PRE>
</TH>
<TR VALIGN=TOP><TD>nCards</TD>
<TD>the actual number of cards may be less than, but not greater than this
</TR>
<TR VALIGN=TOP><TD>baseAddress</TD>
<TD>the base address of the first card of a series.  This must agree
with address jumpers on the actual card(s).
<P>Joerger VS scalers have base addresses in the A16 address space,
on a 2048-byte (0x800) boundary.  (I.e., these cards require 2048 bytes
each, and must all be addressed contiguously as, e.g., 0x2000, 0x2800,...).
</TD></TR>
<TR VALIGN=TOP><TD>intVectBase</TD>
<TD>the interrupt vector that will be loaded into the first card of a
series.  Succeeding cards will be loaded with intVectBase+1,
intVectBase+2, etc.  Stay in the range [64..255].
<TR VALIGN=TOP><TD>intLevel</TD>
<TD>the interrupt level this board should use.</TD>
</TR>
</TABLE>
</FONT>
</blockquote>

<PRE>
scalerVS_Setup(1, 0x2000, 205, 5)
</PRE>

<blockquote>
	<TABLE BORDER CELLPADDING=5>
	<TR><TH COLSPAN=2><PRE>drvSIS3801Config(Port, baseAddress, intVectBase, intLevel, 2048, 32)</PRE></TH></TR>
	<TR VALIGN=TOP><TD>Port
	<TD>name to give to asyn port defined by drvSIS3801Config()
	</TR>
	<TR VALIGN=TOP><TD>baseAddress
	<TD>the base address of the first card of a series.  This must agree
	with address jumpers on the actual card(s).
	<P>SIS3801 scalers have base addresses in the A32 address space,
	on a 2048-byte (0x800) boundary.  (I.e., these cards require 2048 bytes
	each, and must all be addressed contiguously as, e.g., 0x90000000, 0x90000800,...).
	</TD></TR>
	<TR VALIGN=TOP><TD>intVectBase
	<TD>the interrupt vector that will be loaded into the first card of a
	series.  Succeeding cards will be loaded with intVectBase+1,
	intVectBase+2, etc.  Stay in the range [64..255].
	<TR VALIGN=TOP><TD>intLevel
	<TD>the interrupt level this board should use.

	<TR VALIGN=TOP><TD>channels
	<TD>number of channels for each signal.

	<TR VALIGN=TOP><TD>signals
	<TD>number of signals (i.e., counter inputs)
	</TR>
	</TABLE>
</blockquote>
<pre>
drvSIS3801Config($(PORT), 0xA0000000, 220, 6, $(MAX_CHANS), $(MAX_SIGNALS))
</pre>

</table>


<P><TABLE BORDER CELLPADDING=5>
<TR><TH COLSPAN=2>BACKUP/RESTORE (BURT) REQUEST FILES<BR></TH></TR>
<TR VALIGN=TOP><TD>scalerSettings.req   <TD>sample request file to save
settings of one scaler database.  Edit this file, supplying names of
the scaler records whose settings you want saved.  (The sample file
also saves the states of other records in the sample database,
Jscaler.db, that control calculations done when the scaler finishes
counting.)
<TR VALIGN=TOP><TD>yyScalerSettings.req	<TD>save settings of a specified scaler record.  This file is <CODE>#include</CODE>'d (once for each scaler) by scalerSettings.req.

<TR><TD COLSPAN=2>These files tell the backup/restore tool how to save scaler
settings.  To use them from the command line, type, for example
<PRE>
burtrb -f scalerSettings.req -o myScalerSettings.snap<BR>
</PRE>
To restore the scaler settings saved by the above commands, type
<PRE>
burtwb -f myScalerSettings.snap<BR>
</PRE>
</TD>
</TR>

</TABLE>


<HR>
<A NAME="Restrictions"><H2>Restrictions</H2></A>
When AutoCount is enabled, with a very short counting time (TP1) and delay
time (DLY1), the scaler can swamp the network with data.<HR>

<ADDRESS>
Suggestions and comments to: 
<BR><A HREF="mailto:mooney@aps.anl.gov">Tim Mooney</A> : (mooney@aps.anl.gov)
<BR>
</ADDRESS>

</BODY>
</HTML>
